Const GFXx = 800, GFXy = 600
Graphics GFXx,GFXy

HidePointer()

AutoMidHandle True

SeedRnd(MilliSecs())

Const col_red = 0, col_green = 1, col_blue = 3, col_orange = 4

SetBuffer BackBuffer()

bg = LoadImage("gfx/farm.png")
Global crowpic = LoadAnimImage("gfx/bird.png",32,32,0,4)
MaskImage crowpic,255,255,255

Global birddeath = LoadSound("sounds/death.wav")

Color 255,0,0

crowmaker = MilliSecs()

Global font1 = LoadAnimImage("gfx/font1.png",9,13,0,95)

Global explodesound = LoadSound("sounds/explode.wav")

startuppic = LoadImage("gfx/startup.png")
pointerpic = LoadImage("gfx/pointer.png")
HandleImage pointerpic,-8,-16
MaskImage pointerpic,255,255,255

directory$ = "chs.hsd"

Global rocketpic = LoadAnimImage("gfx/rocket.png",8,16,0,3)
MaskImage rocketpic,0,0,0

.startgame
intro = PlayMusic("sounds/intro2.wav")
Repeat
	Cls
	DrawBlock startuppic,GFXx/2,GFXy/2
	
	If RectsOverlap(MouseX(),MouseY(),1,1,467,147,163,62) And MouseDown(1)
		Exit
	EndIf
	If RectsOverlap(MouseX(),MouseY(),1,1,524,226,166,126) And MouseDown(1)
		If ReadFile(directory$)=0
			fileopened = WriteFile(directory$)
			
			WriteInt(fileopened,1000)
			WriteInt(fileopened,500)
			WriteInt(fileopened,100)
			WriteInt(fileopened,50)
			WriteInt(fileopened,25)
			WriteLine(fileopened,"Tainted Instinct")
			WriteLine(fileopened,"Tainted Instinct")
			WriteLine(fileopened,"Tainted Instinct")
			WriteLine(fileopened,"Tainted Instinct")
			WriteLine(fileopened,"Tainted Instinct")
			
			CloseFile(fileopened)
		EndIf
		
		fileopened = ReadFile(directory$)
			
		frstsco = ReadInt(fileopened)
		secnsco = ReadInt(fileopened)
		thirsco = ReadInt(fileopened)
		fortsco = ReadInt(fileopened)
		fithsco = ReadInt(fileopened)
		frstname$ = ReadLine(fileopened)
		secnname$ = ReadLine(fileopened)
		thirname$ = ReadLine(fileopened)
		fortname$ = ReadLine(fileopened)
		fithname$ = ReadLine(fileopened)
		
		CloseFile(fileopened)
		
		Repeat
			Cls
			
			Text 320, 200, "Highscores"
			Text 330, 215, "1." + frstsco + "  " + frstname$
			Text 330, 225, "2." + secnsco + "  " + secnname$
			Text 330, 235, "3." + thirsco + "  " + thirname$
			Text 330, 245, "4." + fortsco + "  " + fortname$
			Text 330, 255, "5." + fithsco + "  " + fithname$
			
			Flip
		Until WaitKey() >= 1
	EndIf
	If RectsOverlap(MouseX(),MouseY(),1,1,388,395,261,78) And MouseDown(1)
		End
	EndIf
	
	DrawImage pointerpic,MouseX(),MouseY()
	
	If Not ChannelPlaying(intro)
		intro = PlayMusic("sounds/intro2.wav")
	EndIf
	
	Flip
Forever

StopChannel(intro)

While Not KeyDown(1)
	DrawBlock bg,GFXx/2,GFXy/2
	
	Text2(15,15,"Scared Crows " + scaredbirds,font1,False,False,"normal")
	Text2(15,30,"Crows In The Field " + numcrows,font1,False,False,"normal")
	numcrows = 0
	
	Oval MouseX()-5,MouseY()-5,10,10,False
	
	If MouseHit(1) Then missile( GFXx/2, GFXy - 45, MouseX(), MouseY() )
	
	If MilliSecs() >= crowmaker + 1000
		num = Rand(0,1)
		If num = 1
			crow( GFXx-16,Rand(64,GFXy-128),Rand(-5,-7.5),Rand(-7.5,7.5) )
		ElseIf num = 0
			crow( 16,Rand(64,GFXy-128),Rand(5,7.5),Rand(-7.5,7.5) )
		EndIf
		
		crowmaker = MilliSecs()
	EndIf
	
	For c.crow = Each crow
		Update_crow(c)
		numcrows = numcrows + 1
	Next
	If numcrows >= 15
		Goto EndGame
	EndIf
	
	For m.missile = Each missile
		scaredbirds = scaredbirds + Update_missile(m)
	Next
	
	For p.particle = Each particle
		Update_particle(p)
	Next
	
	Delay 50
	Flip
Wend

.EndGame
Cls
FlushKeys()
endgamepic = LoadImage("GFX/endgame.png")
DrawBlock endgamepic,GFXx/2,GFXy/2
Flip
WaitKey()
FreeImage endgamepic


If ReadFile(directory$)=0
	fileopened = WriteFile(directory$)
	
	WriteInt(fileopened,1000)
	WriteInt(fileopened,500)
	WriteInt(fileopened,100)
	WriteInt(fileopened,50)
	WriteInt(fileopened,25)
	WriteLine(fileopened,"Tainted Instinct")
	WriteLine(fileopened,"Tainted Instinct")
	WriteLine(fileopened,"Tainted Instinct")
	WriteLine(fileopened,"Tainted Instinct")
	WriteLine(fileopened,"Tainted Instinct")
	
	CloseFile(fileopened)
EndIf

fileopened = ReadFile(directory$)

frstsco = ReadInt(fileopened)
secnsco = ReadInt(fileopened)
thirsco = ReadInt(fileopened)
fortsco = ReadInt(fileopened)
fithsco = ReadInt(fileopened)
frstname$ = ReadLine(fileopened)
secnname$ = ReadLine(fileopened)
thirname$ = ReadLine(fileopened)
fortname$ = ReadLine(fileopened)
fithname$ = ReadLine(fileopened)

CloseFile(fileopened)

Locate 0,0

If scaredbirds > frstsco
	fithsco = fortsco
	fortsco = thirsco
	thirsco = secnsco
	secnsco = frstsco
	frstsco = scaredbirds
	
	fithname$ = fortname$
	fortname$ = thirname$
	thirname$ = secnname$
	secnname$ = frstname$
	frstname$ = Input("you have gotten a new highscore! enter name  ")
	
ElseIf scaredbirds > secnsco
	fithsco = fortsco
	fortsco = thirsco
	thirsco = secnsco
	secnsco = scaredbirds
	
	fithname$ = fortname$
	fortname$ = thirname$
	thirname$ = secnname$
	secnname$ = Input("you have gotten a new highscore! enter name  ")
	
ElseIf scaredbirds > thirsco
	fithsco = fortsco
	fortsco = thirsco
	thirdscore = scaredbirds
	
	fithname$ = fortname$
	fortname$ = thirname$
	thirname$ = Input("you have gotten a new highscore! enter name  ")
	
ElseIf scaredbirds > fortsco
	fithsco = fortsco
	fortsco = scaredbirds
	
	fithname$ = fortname$
	fortname$ = Input("you have gotten a new highscore! enter name  ")

ElseIf scaredbirds > fithsco
	fithsco = scaredbirds
	fithname = Input("you have gotten a new highscore! enter name ")
EndIf

fileout = WriteFile(directory$)

WriteInt(fileout,frstsco)
WriteInt(fileout,secnsco)
WriteInt(fileout,thirsco)
WriteInt(fileout,fortsco)
WriteInt(fileout,fithsco)
WriteLine(fileout,frstname$)
WriteLine(fileout,secnname$)
WriteLine(fileout,thirname$)
WriteLine(fileout,fortname$)
WriteLine(fileout,fithname$)

CloseFile(fileout)

Text 20, 200, "Highscores"
Text 30, 215, "1." + frstsco + "  " + frstname$
Text 30, 225, "2." + secnsco + "  " + secnname$
Text 30, 235, "3." + thirsco + "  " + thirname$
Text 30, 245, "4." + fortsco + "  " + fortname$
Text 30, 255, "5." + fithsco + "  " + fithname$

WaitKey()
Flip

Gosub startgame

End


Type crow
	Field x#,y#
	Field xv#,yv#
	Field frame
End Type

Function crow(x#,y#,xv#,yv#)
	c.crow = New crow
	
	c\x# = x# : c\y# = y#
	c\xv# = xv# : c\yv# = yv#
End Function

Function Update_crow(c.crow)
	c\x# = c\x# + c\xv#
	c\y# = c\y# + c\yv#
	If c\x# < 0
		c\xv# = -c\xv#
		c\x# = 0
	ElseIf c\x# > GFXx
		c\xv# = -c\xv#
		c\x# = GFXx
	EndIf
	
	If c\y# < 0
		c\yv# = Rnd(0,7.5)
		c\y# = 0
	ElseIf c\y# > GFXy - 128
		c\yv# = -Rnd(0,7.5)
		c\y# = GFXy - 128
	EndIf
	
	If c\xv# > 0
		offset = 2
	EndIf
	
	DrawImage crowpic,c\x#,c\y#,c\frame+offset
	c\frame = c\frame + 1
	If c\frame > 1 Then c\frame = 0
End Function

Type missile
	Field x#,y#
	Field dx#,dy#
	Field xv#,yv#
	Field angle
	Field frame
End Type

Function missile(x#,y#,x2#,y2#)
	m.missile = New missile
	
	m\x# = x# : m\y# = y#
	m\dx# = x2# : m\dy# = y2#
	
	m\angle = angle
	m\xv# = -Cos(ATan2( (GFXy - 45) - y2#, (GFXx/2) - x2# ))*15
	m\yv# = -Sin(ATan2( (GFXy - 45) - y2#, (GFXx/2) - x2# ))*15
	
	m\frame = 0
End Function

Function Update_missile(m.missile)
	m\x# = m\x# + m\xv#
	m\y# = m\y# + m\yv#
	
	;Oval m\x#-5,m\y#-5,10,10,True
	DrawImage rocketpic,m\x#,m\y#,m\frame
	m\frame = m\frame + 1
	If m\frame > 2 Then m\frame = 0
	
	If dist(m\x#, m\y#, m\dx#, m\dy#) <= 15
		i = explosion(m\x#,m\y#,Rand(0,4))
		Delete m
	EndIf
	Return i
End Function
	

Type particle
	Field x#,y#
	Field xv#,yv#
	Field col
End Type

Function explosion(x#,y#,col)
	PlaySound explodesound
	For i = 1 To 15
		p.particle = New particle
		
		p\x# = x# : p\y# = y#
		p\xv# = Sin((360/15)*i)*3
		p\yv# = Cos((360/15)*i)*3
		
		p\col = col
	Next
	
	For c.crow = Each crow
		If dist(x#,y#,c\x#,c\y#) <= 64
			Delete c
			PlaySound birddeath
			Return 1
		EndIf
	Next
	
	Return 0
End Function

Function Update_particle(p.particle)
	p\x# = p\x# + p\xv#
	p\y# = p\y# + p\yv#
	p\yv# = p\yv# + .5
	
	Select p\col
		Case col_red
			WritePixel p\x#,p\y#,$ff0000
		Case col_green
			WritePixel p\x#,p\y#,$7f00ff
		Case col_blue
			WritePixel p\x#,p\y#,$0000cc
		Case col_orange
			WritePixel p\x#,p\y#,$ff7f00
	End Select
	
	If p\y# > GFXy
		Delete p
	EndIf
End Function

Function dist(x1,y1,x2,y2)
	dx = x2 - x1
	dy = y2 - y1
	Return Sqr( (dx*dx) + (dy*dy) )
End Function

Function Text2(x#,y#,strng$,font,xalign,yalign,direction$)
	If yalign = True
		ychange# = ImageHeight(font)/2
	Else
		ychange# = 0
	EndIf
	
	For i = 1 To Len(strng$)
		frame = Asc(Mid$(Lower(strng$),i,1)) - 32							;a = 1, b = 2, c = 3, etc. ...
		
		If direction$ = "normal"
			If xalign = True
				xchange# = 1*(i - Ceil(Len(strng$)/2))
				DrawImage font,x#+(ImageWidth(font)*(xchange-1)),y#-ychange#,frame
			Else
				DrawImage font,x#+(ImageWidth(font)*(i-1)),y#-ychange#,frame
			EndIf
		ElseIf direction$ = "down"
			If xalign = True
				ychange# = 1*(i - Ceil(Len(strng$)/2))
				xchange# = ImageWidth(font)/2
				DrawImage font,x#+xchange,y#+(ImageHeight(font)*(ychange-1)),frame
			Else
				DrawImage font,x#-xchange#,y#+(ImageHeight(font)*(i-1)),frame
			EndIf
		EndIf
	Next
End Function